package l85w;

/*
 * LoG85Watcher: Demonio Vigilante de LoG85
 * Copyright (C) 2010 Ernesto Azuar Valenzuela
 * Contacto: lanshor@gmail.com
 *
 * Este programa es Software Libre; usted puede redistribuirlo
 * y/o modificarlo bajo los términos de la "GNU General Public
 * License" como lo publica la "FSF Free Software Foundation",
 * o (a su elección) de cualquier versión posterior.
 *
 * Este programa es distribuido con la esperanza de que le será
 * útil, pero SIN NINGUNA GARANTIA; incluso sin la garantía
 * implícita por el MERCADEO o EJERCICIO DE ALGUN PROPOSITO en
 * particular. Vea la "GNU General Public License" para más
 * detalles.
 *
 * Usted debe haber recibido una copia de la "GNU General Public
 * License" junto con este programa, si no, escriba a la "FSF
 * Free Software Foundation, Inc.", 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.TrayIcon;
import java.awt.SystemTray;
import java.awt.AWTException;
import java.awt.MenuItem;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.net.URL;
import java.net.MalformedURLException;
import java.awt.PopupMenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Calendar;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.Timer;

public class Main
{
    //========================================
    private static int version;
    private static int ultimo_timesptamp;
    private static int error;
    private static String[] cambios;
    private static Image icono;
    private static TrayIcon demonio;
    private static int nuevas;
    private static long desfase;
    private static Calendar ultimo_ping;
    private static boolean silenciar;
    private static boolean error_de_version;
    private static String server;
    //========================================
    Main()
    {
        URL url=getClass().getResource("/icono.gif");
        version=3;
        ultimo_timesptamp=0;
        error=0;
        icono=Toolkit.getDefaultToolkit().createImage(url);
        demonio=new TrayIcon(icono,"Demonio Vigilante de LoG85");
        nuevas=0;
        desfase=0;
        silenciar=false;
        error_de_version=false;
        server="log85.no-ip.org";
    }
    //========================================
    //Métodos
    private static String Tiempo(int tiempo)
    {
        Calendar now=Calendar.getInstance();
        tiempo+=(now.getTimeInMillis()-ultimo_ping.getTimeInMillis())/1000;
        if(tiempo<60) return tiempo+"s";
        if(tiempo<60*60) return (tiempo/60)+"m "+(tiempo%60)+"s";
        if(tiempo<60*60*24) return (tiempo/(60*60))+"h "+((tiempo%(60*60))/60)+"m";
        if(tiempo<60*60*24*10) return (tiempo/(60*60*24))+"d "+((tiempo%(60*60*24))/(60*60))+"h";
        return (tiempo/(60*60*24))+"d";
    }
    private static void MostrarNuevas()
    {
        String cadena="";
        for(int x=0;x<Math.min(nuevas*2,cambios.length)-1;x++,x++)
        {
            int hace=(int)(desfase-(Integer.valueOf(cambios[x+1])));
            cadena+="* "+cambios[x]+" ("+Tiempo(hace)+")\n";
        }
        demonio.displayMessage("Ultimas Acciones",cadena,TrayIcon.MessageType.INFO);
    }
    private static void MostrarTodas()
    {
        if(error>0)
        {
            demonio.displayMessage("Error de Conexión","No he podido conectar con LoG85...",TrayIcon.MessageType.ERROR);
            return;
        }
        String cadena="";
        for(int x=0;x<10;x++,x++)
        {
            if(x<nuevas*2)cadena+="* ";
            int hace=(int)(desfase-(Integer.valueOf(cambios[x+1])));
            cadena+=cambios[x]+" ("+Tiempo(hace)+")\n";
        }
        demonio.displayMessage("Ultimas Acciones",cadena,TrayIcon.MessageType.INFO);
    }
    private static void Cargar(int omitir) throws MalformedURLException, IOException
    {
        URL url=new URL("http://"+server+"/vigilante.php?no_utf8=1");
        BufferedReader in=null;
        try{in=new BufferedReader(new InputStreamReader(url.openStream()));}
        catch(Throwable t)
        {
            if(error==0)
            {
                demonio.displayMessage("Error de Conexión","No he podido conectar con LoG85...",TrayIcon.MessageType.ERROR);
                error++;
            }
        }
        if(in!=null)
        {
            error=0;
            ultimo_ping=Calendar.getInstance();
            String contenido="";
            String linea;
            boolean salir=false;
            while((linea=in.readLine())!=null)
                contenido+=linea;
            String[] datos=contenido.split("<br>");
            if(version==Integer.valueOf(datos[0]))
            {
                desfase=Integer.valueOf(datos[1]);
                cambios=new String[datos.length-1];
                for(int x=2;x<datos.length;x++)
                {
                    cambios[x-2]=datos[x];
                    x++;
                    cambios[x-2]=datos[x];
                    if(Integer.valueOf(datos[x])>ultimo_timesptamp)
                    {
                        salir=true;
                        nuevas++;
                    }
                }
                ultimo_timesptamp=Integer.valueOf(datos[3]);
                if(!silenciar && salir && omitir==0)
                    MostrarNuevas();
            }
            else
            {
                demonio.displayMessage("Error de versión.","Hay una nueva versión del Vigilante de L85 disponible.\n\nDescárgala de 'www.log85.com' en cuanto puedas :)\n\nEste vigilante que tienes instalado no puede funcionar hasta que lo actualices.",TrayIcon.MessageType.ERROR);
                error_de_version=true;
            }
        }
    }
    private static void Fisgonear() throws IOException, InterruptedException, Exception
    {
       String os=System.getProperty("os.name");
       if(os.startsWith("Windows"))
           Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler http://"+server+"/fisgonear.php");
       else
       {
            String[] browsers = {"firefox","opera","konqueror","epiphany","mozilla","netscape"};
            String browser = null;
            for(int count=0;count<browsers.length && browser==null;count++)
               if (Runtime.getRuntime().exec(new String[]{"which", browsers[count]}).waitFor()==0)
                  browser=browsers[count];
            if(browser==null)
               throw new Exception("No encuentro ningún navegador :(");
            else
               Runtime.getRuntime().exec(new String[]{browser,"http://"+server+"/fisgonear.php"});
       }
    }
    //MAIN
    public static void main(String[] args) throws AWTException, MalformedURLException, IOException
    {
        //Incializar
        new Main();
        //Eventos
        ActionListener eventoSalir=new ActionListener()    {public void actionPerformed(ActionEvent e){System.exit(0);}};
        ActionListener eventoMostrar=new ActionListener()  {public void actionPerformed(ActionEvent e){MostrarTodas();}};
        ActionListener eventoMarcar=new ActionListener()   {public void actionPerformed(ActionEvent e){nuevas=0;}};
        ActionListener eventoFisgonear=new ActionListener(){public void actionPerformed(ActionEvent e)
        {
            try{Fisgonear();}
            catch(IOException ex){Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);}
            catch(InterruptedException ex){Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);}
            catch(Exception ex){Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);}
        }};
        //Inicializar
        //---POPUP
        PopupMenu menu=new PopupMenu("Últimas Acciones");
        MenuItem salir=new MenuItem("Salir");
        MenuItem mostrar=new MenuItem("Mostrar últimas 5 actividades");
        MenuItem marcar=new MenuItem("Marcar todas como leídas");
        MenuItem fisgonear=new MenuItem("¡Fisgonear!");
        salir.addActionListener(eventoSalir);
        mostrar.addActionListener(eventoMostrar);
        marcar.addActionListener(eventoMarcar);
        fisgonear.addActionListener(eventoFisgonear);
        menu.add(mostrar);
        menu.add(marcar);
        menu.add(fisgonear);
        menu.add(salir);
        demonio.setImageAutoSize(true);
        demonio.setPopupMenu(menu);
        //---FIN POPUP
        SystemTray systray=SystemTray.getSystemTray();
        systray.add(demonio);
        //Iniciar Carga
        Cargar(1);
        nuevas=0;
        //Iniciar Timer
        if(!error_de_version)
        {
            //Atención: Valores de refesco menores a 30000 milisegundos podrán provocar un baneo indefinido a la IP
            //          No seas avaricioso e impaciente y entiende que esta medida es por seguridad :)
            Timer timer=new Timer(30000,new ActionListener(){public void actionPerformed(ActionEvent e)
            {
                try{Cargar(0);}
                catch(MalformedURLException ex){Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);}
                catch (IOException ex){Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);}
            }});
            timer.start();
        }
    }
}
